<?

//files common to this app
include("app/common.inc.php");
include("app/custom_form.inc.php");
include("app/object.inc.php");

//check the current database version
if (!$_SESSION["dbver_check"]) {
  include("app/dbupgrade.php");
  checkDatabaseVersion();
}

//set the execution time for uploading and file processing
if (defined("EXECUTION_TIME")) ini_set("max_execution_time",EXECUTION_TIME);

//setup which apps are available to docmgr
setExternalApps();

//get our language files
if (!$_SESSION["availLang"]) $_SESSION["availLang"] = retrieveLang();

//process a passed language change
if ($_POST["setLang"]) $_SESSION["curLang"] = $_POST["setLang"];

//use our default language if it is not set
if (!$_SESSION["curLang"]) $_SESSION["curLang"] = DEFAULT_LANG;

include("lang/".$_SESSION["curLang"].".php");

//default charset if missed
if (!defined("LANG_CHARSET")) define("LANG_CHARSET","iso-8859-1");

//default I18N value if missed
if (!defined("LANG_I18N")) define("LANG_I18N","en");

//null our session saying our objects have been loaded
$_SESSION["objectsLoaded"] = null;

/********************************************************************************
  from here, we are going to handle a special mod setting called skip_auth.
  this will perform the module loading and theme display with NO permissions
  checking.  This can only be set in the module.xml file
********************************************************************************/

if ($siteModInfo[$module]["skip_auth"]=="1") {

  $modPath = $siteModInfo[$module]["module_path"];
  $modStylesheet = null;
  $modJs = null;
  $siteContent = null;
  
  //determine our process file and our display file
  $process_path = $modPath."process.php";
  $style_path = $modPath."stylesheet.css";
  $js_path = $modPath."javascript.js";
  $display_path = $modPath."display.php";
  $function_path = $modPath."function.php";

  //load any optional function files in the module directory
  if (file_exists("$function_path")) include("$function_path");
  if (file_exists("$process_path")) include("$process_path");
  
  //these get called by our body.inc.php file
  if (file_exists("$style_path")) $modStylesheet = $style_path;
  if (file_exists("$js_path")) $modJs = $js_path;

  if (file_exists("$display_path")) include("$display_path");

  /********************************************************************
    Call our layout files
  ********************************************************************/
  if (!defined("SITE_THEME")) die("No theme is defined for the site");

  //create a define for referencing all our theme objects (css,layout,images)
  define("THEME_PATH","themes/".SITE_THEME);

  //any display any messages from our modules
  if ($successMessage) $siteMessage = "<div class=\"successMessage\">".$successMessage."</div>\n";
  elseif ($errorMessage) $siteMessage = "<div class=\"errorMessage\">".$errorMessage."</div>\n";
  else $siteMessage = null;

  //call our body file.  This contains the structure for our site.  only the logo page is allowed here
  if ($hideHeader) include(THEME_PATH."/layout/blank.php");
  else include(THEME_PATH."/layout/logo.php");

  //quit processing here
  die;
}  
  