<?php

function time_format($time_entry,$period_value) {

	$hour_value  	=   substr ($time_entry,0,2);
	$minute_value	=	substr ($time_entry,3,2);
	//$period_value	=	substr ($time_entry,7,4);

	//06:25 a.m.

	if ($period_value) {

		if ($period_value=="P.M." && $hour_value!="12") {

			$hour_value=12+$hour_value;

		}

	}

	$time_enter=$hour_value;
	$time_enter.=":";
	$time_enter.=$minute_value;
	$time_enter.=":";
	$time_enter.="00";

	return $time_enter;


}

function time_view($time_entry,$format) {

	$arr = explode(":",$time_entry);

	$hour = $arr[0];
	$min = $arr[1];
	$sec = $arr[2];

	if ($format=="standard") {

		if ($hour>="12") {

			$period="PM";
			if ($hour!=12) $hour=$hour-12;

		} else {
			if ($hour=="0" || $hour=="00") $hour = "12";
			$period="AM";
		}

	}

	$time_show=$hour;
	$time_show.=":";
	$time_show.=$min;

	if ($period) $time_show .= "&nbsp;".$period;

	return $time_show;

}

function time_format_fix($start_hour,$start_min,$starttime_period,$dur_hour,$dur_min) {

	if ($starttime_period=="P.M.") 	$start_hour=$start_hour+12;

	if ($start_hour=="24") {

		if ($starttime_period=="P.M.") $start_hour = "12";
		else $start_hour = "0";

	}

	$start_time=$start_hour.":".$start_min;

	$end_hour=$start_hour+$dur_hour;
	$end_min=$start_min+$dur_min;

	if ($end_min=="0") $end_min="00";

	if ($end_min>=60) {
		$end_hour=$end_hour+1;
		$end_min=$end_min-60;
	}

	if ($end_min=="60") {
		if ($end_hour=="12") $end_hour=="01";
		else $end_hour=$end_hour+1;
		$end_min="00";
	}

	if ($end_hour>=24) $end_hour=$end_hour - 24;

	$end_time=$end_hour.":".$end_min;

	$time_array=array();
	$time_array[0]=$start_time;
	$time_array[1]=$end_time;
	return $time_array;

}


//this function returns the hours and minutes difference between tw times
function time_diff($start_time,$end_time) {

	//subtract our times to get the difference
	$calcStArray = explode(":",$start_time);
	$calcEtArray = explode(":",$end_time);

	$start_hour = $calcStArray[0];
	$start_min = $calcStArray[1];

	$end_hour = $calcEtArray[0];
	$end_min = $calcEtArray[1];

	//reduce our dates to timestamps.  We use a random date here, since it does not matter
	$ts1 = mktime($start_hour,$start_min,"0",1,1,2000);
	$ts2 = mktime($end_hour,$end_min,"0",1,1,2000);

	//get the number of seconds
	$diff = $ts2 - $ts1;

	$temp = $diff/3600;

	//get the place of the decimal point
	$pos = strpos($temp,".");

	//if we have pos, there is a decimal point
	if ($pos) {

		$dur_hour = intval($temp);
		$min = substr($temp,$pos);

		//convert to clock nums
		if ($min==".5") $dur_min = "30";
		elseif ($min==".25") $dur_min = "15";
		elseif ($min==".75") $dur_min = "45";

	}
	else {
		$dur_hour = $temp;
		$dur_min = "00";
	}

	return array($dur_hour,$dur_min);

}

function date_diff($firstDate,$lastDate) {

	$fdArray = explode("-",$firstDate);
	$ldArray = explode("-",$lastDate);

	//get how many days the difference is
	$diff = mktime(0,0,0,$fdArray[1],$fdArray[2],$fdArray[0]) - mktime(0,0,0,$ldArray[1],$ldArray[2],$ldArray[0]);
	$diff = abs($diff / 86400);

	return $diff;
}

//this makes things dates viewable as passed from postgresql's date format
function date_time_view($datetime) {

	if (!$datetime) return true;

	$datetime = trim($datetime);

	$pos = strpos($datetime," ");

	//divide up our string into date and time
	$date_value=substr($datetime,0,$pos);
	$date_value = date_view($date_value,"slash");

	$time_value = substr($datetime,$pos);
	$time_value = time_view($time_value,"standard");

	$datetime=array($date_value,$time_value);
	return $datetime;
}

function dateDisplay($prefix,$header,$date) {

	if (!$date) $date = date("Y-m-d");

	$dateArray = explode("-",$date);
	$monthValue = $dateArray[1];
	$dayValue = $dateArray[2];
	$yearValue = $dateArray[0];

	$string = "<div class=\"formHeader\">".$header."</div>
			<SELECT name=\"".$prefix."_month\" id=\"".$prefix."_month\" onChange=\"fixDay('".$prefix."');\">
			";

	for ($row=1;$row<=12;$row++) {
		if ($monthValue == $row) $selected = " SELECTED ";
		else $selected = null;
		$string .= "<option value=".$row." ".$selected.">".date("M",mktime(0,0,0,$row,1,0));
	}

	$string .= "</SELECT>
				&nbsp;
				<select name=\"".$prefix."_day\" id=\"".$prefix."_day\">";

	for ($row=1;$row<=31;$row++) {
			if ($dayValue == $row) $selected = " SELECTED ";
			else $selected = null;
			$string .= "<OPTION value=\"".$row."\" ".$selected.">".$row;
	}


	$string .= "</SELECT>
				&nbsp;
				<SELECT name=\"".$prefix."_year\">
				";

	$date_loop=date(Y)-1;
	$date_loop_end=$date_loop+3;

	for ($row=$date_loop;$row<$date_loop_end;$row++) {
			if ($yearValue == $row) $selected = " SELECTED ";
			else $selected = null;
			$string .= "<OPTION value=\"".$row."\" ".$selected.">".$row;
	}

	$string .= "</select>";

	return $string;

}

function dateForm1($title,$name,$value) {

	$posname = $name."_cursorpos";

	$string .= "<input type=hidden name=\"".$posname."\" id=\"".$posname."\">";
	if ($title) $string .= "<div class=\"formHeader\">".$title."</div>";

	$value = trim($value);

	if ($value) {
		
		/*  Split up the string form_home_phone string */
		$dArray = explode("-",$value);
		
		$yearValue = $dArray[0];
		$monthValue = $dArray[1];
		$dayValue = $dArray[2];
		
	}

	$month = "<input  	class=\"textbox\" 
					type=text size=\"2\" 
					MAXLENGTH=\"2\" 
					name=\"".$name."Month\" 
					id=\"".$name."Month\"
					value=\"".$monthValue."\" 
					onKeyDown=\"KEYDOWN\"
					onClick=\"ONSELECT\"
					onFocus=\"ONFOCUS\"
					>
					";

	$day = "<input  	class=\"textbox\" 
					type=text size=\"2\" 
					MAXLENGTH=\"2\" 
					name=\"".$name."Day\" 
					id=\"".$name."Day\"
					value=\"".$dayValue."\" 
					onKeyDown=\"KEYDOWN\"
					onSelect=\"ONSELECT\"
					onFocus=\"ONFOCUS\"
					>
					";						


	$year = "<input  	class=\"textbox\" 
					type=text size=\"4\" 
					MAXLENGTH=\"4\" 
					name=\"".$name."Year\" 
					id=\"".$name."Year\"
					value=\"".$yearValue."\" 
					onKeyDown=\"KEYDOWN\"
					onSelect=\"ONSELECT\"
					onFocus=\"ONFOCUS\"
					>
					";						


	if (defined("DATE_FORMAT")) $dateForm = DATE_FORMAT;
	else $dateForm = "mm/dd/yyyy";

	$tempForm = $dateForm;

	$tempForm = str_replace("mm","Month",$tempForm);	
	$tempForm = str_replace("dd","Day",$tempForm);	
	$tempForm = str_replace("yyyy","Year",$tempForm);	

	$dateArray = explode("/",$tempForm);
	
	for ($row=0;$row<count($dateArray);$row++) {

		if ($row=="0") {
			$cur = $dateArray[0];
			$prev = $dateArray[0];
			$next = $dateArray[1];
		} elseif ($row=="2") {
			$cur = $dateArray[2];
			$prev = $dateArray[1];
			$next = $dateArray[2];
		} else {
			$cur = $dateArray[1];
			$prev = $dateArray[0];
			$next = $dateArray[2];
		}

		$keyDown = "fieldJump('".$name.$cur."','".$name.$prev."','".$name.$next."');";
		$onSelect = "saveCaret('".$name.$cur."');";
		$onFocus = "saveCaret('".$name.$cur."');";

		if ($cur=="Month") $val = &$month;
		elseif ($cur=="Day") $val = &$day;
		elseif ($cur=="Year") $val = &$year;

		$val = str_replace("KEYDOWN",$keyDown,$val);
		$val = str_replace("ONSELECT",$onSelect,$val);
		$val = str_replace("ONFOCUS",$onFocus,$val);

	}

	$dateForm = str_replace("/","-",$dateForm);
	$dateForm = str_replace("mm",$month,$dateForm);	
	$dateForm = str_replace("dd",$day,$dateForm);	
	$dateForm = str_replace("yyyy",$year,$dateForm);	

	$string .= $dateForm;
	
	return $string;
	
}

function dateForm($title,$name,$value) {

	if (defined("DATE_FORMAT")) $layout = DATE_FORMAT;
	else $layout = "mm/dd/yyyy";
	$layout = strtoupper($layout);

	if ($title) $string .= "<div class=\"formHeader\">".$title."</div>";

	$value = trim($value);

	if ($value) $value = date_view($value,"slash");

	$string .= "<input 	class=\"textbox\" 
					type=text 
					name=\"".$name."\" 
					id=\"".$name."\" 
					value=\"".$value."\"
					>";

	return $string;
	
}

function dateFormat($date) {

	return dateProcess($date);

}

function dateProcess($date) {

	if (!$date) return false;

	if (defined("DATE_FORMAT")) $layout = DATE_FORMAT;
	else $layout = "mm/dd/yyyy";

	$layoutArray = explode("/",$layout);
	
	$monthKey = array_search("mm",$layoutArray);
	$dayKey = array_search("dd",$layoutArray);
	$yearKey = array_search("yyyy",$layoutArray);

	if (strpos($date,"/")) $sep = "/";
	else $sep = "-";

	$dateArray = explode($sep,$date);
	
	$month = $dateArray[$monthKey];
	$day = $dateArray[$dayKey];
	$year = $dateArray[$yearKey];

	return $year."-".$month."-".$day;	

}

function date_view($date,$format = "slash") {

	if (defined("DATE_FORMAT")) $layout = DATE_FORMAT;
	else $layout = "mm/dd/yyyy";

	$layout = str_replace("mm","m",$layout);
	$layout = str_replace("dd","d",$layout);
	$layout = str_replace("yyyy","Y",$layout);

	if ($format=="slash" && $date) {

		$dateArray = explode("-",$date);

		$date = date("$layout",mktime(0,0,0,$dateArray[1],$dateArray[2],$dateArray[0]));

	}
	else if ($format=="space" && $date) {

		$dateArray = explode("-",$date);

		$date = date("M d, Y",mktime(0,0,0,$dateArray[1],$dateArray[2],$dateArray[0]));

	}

	return $date;
}

function dateView($date) {

	$arr = date_time_view($date);
	
	$str = $arr[0]." "._AT." ".$arr[1];

	return str_replace(" ","&nbsp;",$str);
}

//loads a date form with a popup calendar select
function dateFormSelect($header,$formName,$formValue,$readonly="READONLY") {

	//extend the form name to the name of our button
	$btnName = $formName."Btn";

	//assemble our form
	$str = "<div class=\"formHeader\">
		".$header."
		</div>
		<input type=text size=10 ".$readonly." name=\"".$formName."\" id=\"".$formName."\" value=\"".$formValue."\">
		<input type=button name=\"".$btnName."\" id=\"".$btnName."\" value=\"...\">
		";

	//call our js function and setup loaders
	$str .= jsCalLoad();
	$str .= jsCalSetup($formName,$btnName);

	return $str;

}

//loads a date form with a popup calendar select
function dateTimeFormSelect($header,$formName,$formValue,$readonly="READONLY") {

	//extend the form name to the name of our button
	$btnName = $formName."Btn";

	//assemble our form
	$str = "<div class=\"formHeader\">
		".$header."
		</div>
		<input type=text size=20 ".$readonly." name=\"".$formName."\" id=\"".$formName."\" value=\"".$formValue."\">
		<input type=button name=\"".$btnName."\" id=\"".$btnName."\" value=\"...\">
		";

	//call our js function and setup loaders
	$str .= jsCalLoad();
	$str .= jsCalSetup($formName,$btnName,1);

	return $str;

}


//loads the required javascript files for our calendar to work
function jsCalLoad() {

	//get out if this has already been loaded
	if (defined("JSCAL_LOADED")) return false;

	//make sure this doesn't get loaded again
	define("JSCAL_LOADED","1");

	//get our language file
	$langFile = "javascript/calendar/lang/calendar-".LANG_I18N.".js";

	//default to english if it does not exist
	if (!file_exists($langFile)) $langFile = "javascript/calendar/lang/calendar-en.js";

	$str = "
  	<!-- calendar stylesheet -->
  	<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\"javascript/calendar/skins/aqua/theme.css\" title=\"Aqua\" />

  	<!-- main calendar program -->
  	<script type=\"text/javascript\" src=\"javascript/calendar/calendar.js\"></script>

  	<!-- language for the calendar -->
  	<script type=\"text/javascript\" src=\"".$langFile."\"></script>

  	<!-- the following script defines the Calendar.setup helper function, which makes
       adding a calendar a matter of 1 or 2 lines of code. -->
  	<script type=\"text/javascript\" src=\"javascript/calendar/calendar-setup.js\"></script>

	";
	
	return $str;
	
}

//sets up the calendar to work with a specific input field or id, which
//is passed as the first parameter
function jsCalSetup($formName,$btnName,$showTime = null) {

	//get our date format from the define if set
	if (defined("DATE_FORMAT")) $dateFormat = strtolower(DATE_FORMAT);
	else $dateFormat = "mm/dd/yyyy";

	//rewrite our php format to work with javascript
	$dateFormat = str_replace("mm","%m",$dateFormat);
	$dateFormat = str_replace("dd","%d",$dateFormat);
	$dateFormat = str_replace("yyyy","%Y",$dateFormat);

	//allow time selection as well if desired
	if ($showTime) {
		$setupStr = "ifFormat       :    \"".$dateFormat." %I:%M %p\",       // format of the input field\n";
        	$setupStr .= "showsTime      :    true,            // will display a time selector\n";
	}
	else {
		$setupStr = "ifFormat	:	\"".$dateFormat."\",\n";
	}

	//output our setup string
	$str = "

	<script type=\"text/javascript\">
    	Calendar.setup({
        	inputField     	:    \"".$formName."\",      // id of the input field
		".$setupStr."
        	button         	:    \"".$btnName."\",   // trigger for the calendar (button ID)
        	singleClick    	:    true,           // double-click mode
        	step           	:    1                // show all years in drop-down boxes (instead of every other year as default)
    	});
	</script>

	";
	
	return $str;

	/* other options for the calendar
	*/

}




