<?

//use this function to send emails w/ or w/o attachments to recipients
function send_email($to,$from,$subject,$message,$attachArray) {

	//trim returnAddr to try and prevent the ATTACK messages
	$from = trim($from);
	$to = trim($to);

	//get rid of all formatting in the message
	$str = eregi_replace("<br>","\r\n",$message);
	$str = strip_tags($str);

	/*
	//encode the message
	if (defined("PHP_IMAP_SUPPORT")) $TEXT = imap_8bit("$str");
	else {

		//dump our content to a file, and run that file through mimencode
		//before continuing
		$rand = TMP_DIR."/".rand();

		$fp = fopen($rand,w);
		fwrite($fp,$message);
		fclose($fp);

		$TEXT = `cat "$rand" | mimencode -q`;

		unlink($rand);
		
	}
	*/

	$TEXT = $str;
	
	//add From: header
	$headers = "From: ".$from."\r\n";

	//specify MIME version 1.0
	$headers .= "MIME-Version: 1.0\r\n";

	//process for a plain-text message
	if (!is_array($attachArray)) {
	
		//tell e-mail client this e-mail contains//alternate versions
		//note that enclosing the boundary in quotes allows MIME email
		//to work with AOL.
		$headers .= "Content-Type: text/plain; charset=ISO-8859-1; format=flowed\r\n";
		$headers .= "Content-Transfer-Encoding: 7bit\r\n\r\n";
		$headers .= $TEXT;
		$headers .= "\r\n\r\n";

	//process for an email with an attachment	
	} else {

		//unique boundary
		$boundary = uniqid("----=_NextPart_").".EW_----";

		//tell e-mail client this e-mail contains//alternate versions
		//note that enclosing the boundary in quotes allows MIME email
		//to work with AOL.
		$headers .= "Content-Type: multipart/mixed; boundary=\"".$boundary."\"\r\n";
		$headers .= "Content-Transfer-Encoding: 7bit\r\n\r\n";

		//message to people with clients who do not understand MIME
		$headers .= "This is a multi-part message in MIME format.\r\n";

		//plain text version of message
		$headers .= "--$boundary\r\n";
		$headers .= "Content-Type: text/plain; charset=ISO-8859-1; format=flowed\r\n";
		$headers .= "Content-Transfer-Encoding: 7bit\r\n\r\n";
		$headers .= $TEXT;
		$headers .= "\r\n\r\n";

		/*
		//HTML version of message
		$headers .= "--$boundary\r\n";
		$headers .= "Content-Type: text/html; charset=ISO-8859-1\r\n";
		$headers .= "Content-Transfer-Encoding: quoted-printable\r\n\r\n";

		$headers .= $HTML;
		*/

		//loop through and add all attachments
		foreach ($attachArray AS $attach) {

			$attachPath = $attach["path"];
			$attachName = $attach["name"];
			$attachDesc = $attach["description"];
			$attachType = $attach["type"];

			//get the file as a string and encode
			$h = fopen($attachPath,"rb");
			$contents = fread($h,filesize($attachPath));
			fclose($h);

			$FILE = chunk_split(base64_encode($contents));

			$headers .= "--$boundary\r\n";
		  	$headers .= "Content-Type: application/octet-stream; name=\"".$attachName."\"\r\n";
		   	$headers .= "Content-Transfer-Encoding: base64\r\n";
			$headers .= "Content-Disposition: attachment; filename=\"".$attachName."\"\r\n\r\n";
			$headers .= $FILE;

		}

		$headers .= "\r\n--$boundary--\r\n";
		
	}
	

	$subject = stripslashes($subject);

	//use php_imap if available, otherwise use sendmail
	if (defined("PHP_IMAP_SUPPORT")) {

		if (imap_mail("$to","$subject","","$headers","")) return true;
		else return false;

	} else {

		//prepend the destination and subject to the headers
		$to = "To: ".$to."\r\n";
		$subject = "Subject: ".$subject."\r\n";
		
		$headers = $to.$subject.$headers;

		//write our headers to a temp file for passing to sendmail	
		$file = TMP_DIR."/".rand().".eml";
	
		$fp = fopen($file,w);
		fwrite($fp,$headers);
		fclose($fp);
		
		//pass the file to sendmail
		`cat "$file" | sendmail -t -f "$from"`;

		//remove the temp file and exit
		unlink($file);
		return true;

	}
}
