<?php

function bitset_compare($bit1,$bit2,$admin) {

	$auth = null;

	if ( (int)$bit1 & (int)$bit2 ) $auth = 1;

	if ($admin) {

		if ( (int)$bit1 & (int)$admin ) $auth = 1;

	}

	if (!$auth) return false;
	else return true;

}


/*
  returns the type of browser the user is using.
  this function must be passed $HTTP_USER_AGENT.
*/


function dbInsertQuery($conn,$table,$option,$sanitize = null) {

	$ignoreArray = array("conn","table","debug");

	$keys = array_keys($option);

	$fieldString = null;
	$valueString = null;

	for ($row=0;$row<count($keys);$row++) {

		$field = $keys[$row];
		$value = $option[$field];

		if (!in_array($field,$ignoreArray) && $value!=null) {

			$fieldString .= $field.",";
			
			if ($sanitize) 
				$valueString .= "'".sanitize($value)."',";
			else
				$valueString .= "'".$value."',";

		}	


	}

	if ($fieldString && $valueString) {

		$fieldString = substr($fieldString,0,strlen($fieldString) - 1);
		$valueString = substr($valueString,0,strlen($valueString) - 1);
			
		$sql = "INSERT INTO $table (".$fieldString.") VALUES (".$valueString.");";
		if ($option["debug"]) echo $sql."<br>";

		if ($result = db_query($conn,$sql)) {
	
			$returnId = db_insert_id($table,"id",$conn,$result);	
			if ($returnId) return $returnId;
			else return true;

		} else return false;

	} else return false;

}

function dbUpdateQuery($conn,$table,$option,$sanitize = null) {

	$ignoreArray = array("conn","table","where","debug");

	$keys = array_keys($option);

	$queryString = null;

	for ($row=0;$row<count($keys);$row++) {

		$field = $keys[$row];
		$value = $option[$field];

		if (!in_array($field,$ignoreArray)) {

			if ($value!=null) {
				if ($sanitize) 
					$queryString .= $field."='".sanitize($value)."',";
				else
					$queryString .= $field."='".$value."',";
			}
			else $queryString .= $field."=NULL,";
		} 	


	}

	if ($queryString) {

		$queryString = substr($queryString,0,strlen($queryString) - 1);
			
		$sql = "UPDATE $table SET ".$queryString." WHERE ".$option["where"];

		if ($option["debug"]) echo $sql."<br>";

		if (db_query($conn,$sql)) return true;
		else return false;

	} else return false;

}


function browser_check($var) {

	if (eregi("MSIE",$var)) {
		$browser_type="ie";
	}
	else {
		$browser_type="mozilla";
	}
	echo strpos($HTTP_USER_AGENT,"MSIE");
	return $browser_type;
}

function returnModuleOwner($id,$ownerArray) {

	$siteModSettings = $_SESSION["siteModSettings"];

	$key = array_search($id,$siteModSettings["modId"]);
	$owner = $siteModSettings["modOwner"][$key];

	//if 0, we have reached the top.  Just return the array as is.
	if ($owner=="0") return $ownerArray;
	else {

		//this one also is owned by another module.  Add to the array and check again
		$ownerArray[] = $owner;
		$ownerArray = returnModuleOwner($owner,$ownerArray);

		//return the new ownerArray
		return $ownerArray;

	}

}


function delcheck ($string) {

/*  This function checks to see if the string has anything bad that could
erase more than it is supposed to */

	if (stristr ($string,"*")) return false;
	else if (stristr ($string,"?")) return false;
	else if (stristr ($string,"%")) return false;
	else if (stristr ($string,"!")) return false;
	else if (stristr ($string,"#")) return false;
	else if (stristr ($string,"@")) return false;
	else return true;
}


function intPercent($num,$total) {

	if ($total != 0) {

		$percent = ($num/$total) * 100;
		$temp = intval($percent) + ".5";

		//round up if necessary
		if ($percent >= $temp) {
			$value = intval($percent) + 1;
		}
		else {
			$value = intval($percent);
		}

	}
	else $value = "0";

	return $value;

}

function intValue($num) {

	$temp = intval($num) + ".5";

	//round up if necessary
	if ($num >= $temp) {
		$value = intval($num) + 1;
	}
	else {
		$value = intval($num);
	}

	return $value;

}

function floatValue($num,$count) {

  $pos = strpos($num,".") + 1 + $count;

  $floatNum = substr($num,0,$pos);
  $checkDigit = substr($num,strlen($floatNum),1);

  $changeDigit = substr($floatNum,strlen($floatNum)-1,1);

  //round up if necessary
  if ($checkDigit>=5) $last = $changeDigit + 1;
  else $last = $changeDigit;

  $value = substr($floatNum,0,strlen($floatNum)-1).$last;

  return $value;

}

function bitCal($limit) {

	$num = 1;

	for ($row=0;$row<$limit;$row++) {
		if ($limit!=0) $num = $num * 2;
	}

	return $num;
}

function revBitCal($limit) {

	$counter = "0";

	while ($limit!="1") {

		$counter++;
		$limit = $limit/2;
	}

	return $counter;

}


function getPath($modArray,$id,$path) {

	//do a search for our id to get the key
	$key = array_search($id,$modArray["modId"]);

	$path = $modArray["modDirectory"][$key]."/".$path;

	//is their an owner
	if ($modArray["modOwner"][$key]!="0") {

		$id = $modArray["modOwner"][$key];

		$path = getPath($modArray,$id,$path);

	}

	return $path;

}


function getGroupPath($conn,$id,$path) {

	//get all groups and store them in an array
	$sql = "SELECT owner,path FROM in_groups WHERE id='$id'";
	$info = single_result($conn,$sql);
	
	if ($info) {

		$owner = $info["owner"];
		$newPath = $info["path"];

		$path = $newPath."/".$path;

		if ($owner!="0") $path = getGroupPath($conn,$owner,$path);

	}

	return $path;

}


function getOwner($bitpos,$ownerArray,$bitposArray,$string) {

	$string .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td>";

	$key = array_search($bitpos,$bitposArray);

	if ($ownerArray[$key]!="0") $string = getOwner($bitpos,$ownerArray,$bitposArray,$string);
	else return $string;

}


/************************************************************************************
	This function displays a permissions list for an object, and checks
	any boxes the user belongs to
************************************************************************************/

function groupPerm($conn,$optionArray) {

	$table = $optionArray["table"];
	$filter = $optionArray["filter"];
	$filterValue = $optionArray["filterValue"];
	$permArray = $optionArray["permArray"];
	$prefix = $optionArray["prefix"];
	$bitValue = $optionArray["bitValue"];

	//display all permissions that belong to this app
	$sql = "SELECT * FROM $table";

	if ($filter) $sql .= " WHERE $filter='$filterValue'";

	$sql .= " ORDER BY bitpos";

	$list = total_result($conn,$sql);
	
	$perm_id_array 	= 	&$list["id"];
	$perm_name_array 	= 	&$list["name"];
	$perm_bitpos_array 	= 	&$list["bitpos"];
	$perm_owner_array 	= 	&$list["owner"];

	$string = "<table border=0 cellpadding=0 cellspacing=0>";

	//display an error message if no perms exist for this app
	if (count($perm_id_array)==0) $string .= "<tr><td>No permissions are defined.</td></tr>";
	else {

		for ($num=0;$num<count($perm_id_array);$num++) {

			$bitSet = bitCal($perm_bitpos_array[$num]);

			$hideCheckbox = null;

			//if ($bitSet == $bitAdmin) if (!(bitset_section(BITSET,ADMIN,null))) $hideCheckbox = 1;

			if (!$hideCheckbox) {

				if ($bitValue & $bitSet) $checked = " CHECKED ";
				else $checked = null;

				$string .= "<tr><td valign=top >";
				$string .= "<table cellpadding=0 cellspacing=0><tr><td>";

				//add extra cells if this is a subPerm
				if ($perm_owner_array[$num]!="0") $string .= getOwner(	$bitpos,
											$perm_owner_array,
											$perm_bitpos_array,
											null);

				//create id of checkbox
				$idValue = $prefix."Perm".$perm_bitpos_array[$num];

				//get id of checkbox owner if there is one
				if ($perm_owner_array[$num]!=0) $passId = $prefix."Perm".$perm_owner_array[$num];
				else $passId="0";

				//print out the checkbox
				$string .= "<input type=checkbox
					id=\"".$idValue."\"
					name=\"".$prefix."Permission[]\"
					".$checked."
					value=\"".$bitSet."\">&nbsp;";

				$string .= "</td><td colspan=5>";

				$string .= $perm_name_array[$num];

				$string .= "</td></tr></table>";
				$string .= "</td></tr>";
			}
		}
	}
	$string .= "</table>";

	return $string;

}


function fileExtension($file) {

	$pos = strrpos($file,".");
	if ($pos == "0") return false;
	else {

		$ext = strtolower(substr($file,$pos));

		return $ext;

	}
}

function fileIncludeType($ext) {

	$imageArray = array(	".jpg",
							".png",
							".bmp",
							".gif",
							".tif",
							".tiff",
							".jpeg"
							);

	$embedArray = array(	".avi",
							".pdf",
							".mov",
							".doc"
							);



	if (in_array($ext,$embedArray)) return "embed";
	elseif (in_array($ext,$imageArray)) return "image";
	else return "include";

}

function login_return($conn,$id) {

	//return anonymous if there is no id
	if ($id=="0" || !$id) return SITE_ADMIN;

	$sql = "SELECT login FROM auth_accounts WHERE id='$id'";

	if ($value = single_result($conn,$sql)) return $value["login"];
	else return false;

}

function functionMenu($tableName,$nameList,$functionList) {

	if (BROWSER=="mozilla") $leave = "onBlur=\"document.getElementById('".$tableName."').style.visibility='hidden';\"";
	else $leave="onMouseLeave=\"hideFunctionMenu('".$tableName."',event);\"";

	$string = "<div id=\"".$tableName."\" ".$leave." 
			style=\"visibility:hidden;position:absolute\" 
			class=\"functionMenu\">  ";

	for ($row=0;$row<count($nameList);$row++) {

		$id = $tableName."Cell".$row;

		$string .= "
			<div id=\"".$id."\" class=\"functionMenuCell\"
					onMouseOver=\"changeStyle('".$id."','highlight');\"
					onMouseOut=\"changeStyle('".$id."','normal');\"
					unselectable=\"on\"
					onClick=\"".$functionList[$row].";\"
					>
				".$nameList[$row]."
			</div>
			";
	}

	$string .= "</table></div>";

	return $string;

}

function selfClose() {

	echo "<script type=\"text/javascript\">
		var url = window.opener.location.href;
		window.opener.location.href = url;
		self.close();
		</script>
		";

}

function selfFocus() {

	echo "<script type=\"text/javascript\">\n";
	echo "self.focus();\n";
	echo "</script>\n";

}

function includeStylesheet($path) {

	echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"".$path."\">\n";

}

function includeJavascript($path) {

	echo "<script src=\"".$path."\"></script>\n";

}

function getmicrotime() {

	list($usec, $sec) = explode(" ",microtime());
	return ((float)$usec + (float)$sec);

}

function preventCache() {

	Header("Cache-control: private, no-cache");
	Header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	Header("Pragma: no-cache");

}

function translateHtmlEntities($string) {

	$trans_tbl = get_html_translation_table(HTML_ENTITIES);
	$trans_tbl = array_flip($trans_tbl);
	
	$original = strtr($string,$trans_tbl);

	return $original;
}

function permInsert($conn,$table,$field,$objectId,$level) {

     if (!$level) $level = "0";

     //see if any permissions entries exist
     $sql = "SELECT * FROM $table WHERE $field='$objectId'";
     $num = num_result($conn,$sql);

     //update the record if it exists.  If it does not, create it
     if ($num=="0") $sql = "INSERT INTO $table ($field,bitset) VALUES ('$objectId','$level');";
     else  $sql = "UPDATE $table SET bitset='$level' WHERE $field='$objectId';";
     
     if ($sql) db_query($conn,$sql);

}

/*************************************************************************************
	checkStrongPassword:
	checks the password to see if it is considered difficult to crack.
	Returns a string containing what it thinks is wrong with your password.  
	If "strong password" is returned, then all is well.  cracklib must be 
	compiled into php, or this will generate a php error
**************************************************************************************/
function checkStrongPassword($conn,$accountId,$pwd) {

	//if there is no accountId, return false since we can't check against the username
	if (!$accountId) return "no account id specified";

	$info = returnAccountInfo($conn,$accountId,null);
	$login = &$info["login"];
	$fn = &$info["first_name"];
	$ln = &$info["last_name"];

	//make sure the user's first name, last name, and login aren't in the password
	if (stristr($pwd,$login)) return "it contains your username";
	if (stristr($pwd,$fn)) return "it contains your name";
	if (stristr($pwd,$ln)) return "it contains your name";

	// Perform password check with craclib
	$check = crack_check($pwd);

	// Retrieve messages from cracklib
	return crack_getlastmessage();

}


//this is a smart addslashes function.  It will determine if magic_quotes_gpc
//is on.  If it is not on, it will addslashes to the string.  You will only
//want to use this on variables directly submitted from a form.
function smartslashes($string) {

	$int = get_magic_quotes_gpc();
	
	//magic_quotes is on, return the string as is
	if ($int=="1")	return $string;

	//mq is off, escape the string and return it
	else return addslashes($string);

}


//this function figures out the path to our files, based on whether or
//not the filePath is relative
function getFilePath($filePath,$altFilePath) {

	//there is a leading slash, it's an absolute path
	if ($filePath[0]=="/") return $filePath;
	else {

		//return our relative path appended to the path
		//of the docmgr installation
		return $altFilePath."/".$filePath;

	}

}


/*******************************************************************
	this function spits out the files in chunks to 
	allow for larger files to be downloaded even though
	memory_limit is low. 
*******************************************************************/

function readfile_chunked ($filename) {

	$chunksize = 1*(1024*1024); // how many bytes per chunk (this is 1 mb)

	$buffer = null;

	if (!$handle = fopen($filename, 'rb')) return false;

	while (!feof($handle)) {
		$buffer = fread($handle, $chunksize);
		print $buffer;
	}

	return fclose($handle);

} 


function createXmlHeader($type) {

	header("Content-Type: text/xml");

	$str = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>\n";
	$str .= "<data>\n";
	$str .= "\t<typeid>".$type."</typeid>\n";

	return $str;

}

function createXmlFooter() {

	return "</data>\n";		

}

//encases the data in its xml tags and CDATA declaration
function xmlEntry($key,$data,$ignore = null) {

	$str = "<".$key.">";
	if ($data) {
		if ($ignore) $str .= $data;
		else $str .= "<![CDATA[".$data."]]>";
	}
	$str .= "</".$key.">\n";

	return $str;

}

//make the data safe to be inserted in the database.
//this will handle strings or single level arrays
function sanitize($obj) {

	if (is_array($obj)) {
		$keys = array_keys($obj);
		foreach ($keys AS $key) $obj[$key] = sanitizeString($obj[$key]);
	}
	else $obj = sanitizeString($obj);
	
	return $obj;

}

//actually perform the sanitation
function sanitizeString($str) {

	//stop magic quotes from screwing up our proper escaping of the string
	if (get_magic_quotes_gpc()) $str = stripslashes($str);
	
	return db_escape_string(strip_tags($str));
	
}

//cleans sanitize string for display
function stripsan($str) {

	return stripslashes(db_unescape_string($str));

}

//sanitizes all get,post,request, and cookie variables
function sanitizeRequest() {

	$exempt = array();

	//parse our exemption field if necessary
	if (defined("EXEMPT_SANITIZE")) {
		$exempt = explode(",",EXEMPT_SANITIZE);
	}		

	//the request sg
	$keys = array_keys($_REQUEST);
	foreach ($keys AS $key) {
		//skip if the variable is marked for exemption
		if (in_array($key,$exempt)) continue;
		$_REQUEST[$key] = sanitize($_REQUEST[$key]);	
	}

	//the post sg
	$keys = array_keys($_POST);
	foreach ($keys AS $key) {
		//skip if the variable is marked for exemption
		if (in_array($key,$exempt)) continue;
		$_POST[$key] = sanitize($_POST[$key]);	
	}

	//the get sg
	$keys = array_keys($_GET);
	foreach ($keys AS $key) {
		//skip if the variable is marked for exemption
		if (in_array($key,$exempt)) continue;
		$_GET[$key] = sanitize($_GET[$key]);	

	}

	//the cookie sg
	$keys = array_keys($_COOKIE);
	foreach ($keys AS $key) {

		//skip if the variable is marked for exemption
		if (in_array($key,$exempt)) continue;
		$_COOKIE[$key] = sanitize($_COOKIE[$key]);	

	}

}

//update the settings for an account
function updateAccountSetting($conn,$accountId,$opt) {

	$sql = "SELECT account_id FROM auth_settings WHERE account_id='$accountId'";
	$info = single_result($conn,$sql);

	$opt["account_id"] = $accountId;
	
	//start appending values to send to the database
	if ($info) {
		$opt["where"] = "account_id='$accountId'";
		dbUpdateQuery($conn,"auth_settings",$opt);
	} else {
		dbInsertQuery($conn,"auth_settings",$opt);
	}

}

/*****************************************************************************
  this function converts an ldap filter to a sql query.  This
  is very simple at the moment and doesn't even support collation.
  When passing filters, use the field names and described in the sql
  database.  i.e.  (&(first_name=John)(last_name=Doe))
*****************************************************************************/
function ldap2sql($str) {

  //make sure it is formatted correctly
  $num1 = substr_count($str,"(");
  $num2 = substr_count($str,")");
  
  if ($num1!=$num2) {
    echo "Improperly formatted query string";
    return false;
  }

  //convert wildcards
  $str = str_replace("*","%",$str);
  
  //parse the query  
  $str = parseLdapQuery($str);

  return $str;
  
}

//parse the components of our query
function parseLdapQuery($str) {

  $con = substr($str,0,2);
  $newstr = null;

  //determine our join
  if ($con=="(&") $join = " AND ";
  else $join = " OR ";

  //handle a query that isn't enclosed in its own set of brackets
  if ($str[1]=="&" || $str[1]=="|") $len = "2";
  else $len = "1";
  
  //remove the container
  $str = substr($str,$len);
  $str = substr($str,0,strlen($str) - 1);

  //convert to an array
  $arr = explode(")(",$str);
  $len = count($arr);

  foreach ($arr AS $entry) {

      //remove any leftover brackes
      $entry = str_replace("(","",$entry);
      $entry = str_replace(")","",$entry);

      if (strstr($entry,"!=")) $op = "!=";
      else $op = "=";
    
      //parse into our field/value pairs
      $pos = strpos($entry,$op);
      $field = addslashes(substr($entry,0,$pos));
      $data = addslashes(substr($entry,$pos + strlen($op)));  

      if ($op=="=" && ($data==null || $data=="NULL")) $newstr .= " $field IS NULL ".$join." ";
      elseif ($op=="!=" && ($data==null || $data=="NULL")) $newstr .= " $field IS NOT NULL ".$join." ";
      else $newstr .= " $field = '$data' ".$join." ";
  
  }

  $newstr = substr($newstr,0,strlen($newstr) - (strlen($join) + 1));

  return $newstr;
  
}

function debugMsg($level,$msg) {

  if (php_sapi_name()=="cli") $sep = "\n";
  else $sep = "<br>";
  
  if (DEBUG >= $level) echo $msg.$sep;

}

